# -*- coding: utf-8 -*-
"""KFOLD.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1Kdt8akTtoB0Kl4boxe6e3zJ67BwFqb0M
"""
"""
import os
os.chdir("/")

from google.colab import drive
try:
    drive.mount('content/gdrive', force_remount=True)
except:
    print('你的 drive 掛載不成功')
    
os.chdir("/content/gdrive/My Drive/")

os.chdir("/content/gdrive/My Drive/joint_bert")
"""

import os
import sys
import pandas as pd
from sklearn.model_selection import KFold
import datetime

folder = "Data"

Task_label = datetime.datetime.now().date() if len(sys.argv) == 1 else sys.argv[1]
data = pd.read_csv('../{}/{}/source.csv'.format(folder, Task_label), sep='\t', header=None)
kf = KFold(n_splits=5, random_state=2019, shuffle=True)

for k_fold_index, (train_index, test_index) in enumerate(kf.split(data)):
    test_index_len = len(test_index)
    val_index = test_index[::2]
    test_index = test_index[1::2]
    train_data, val_data, test_data = data.iloc[train_index], data.iloc[val_index], data.iloc[test_index]
    
    if not os.path.exists('../Data/{}/train/data{}'.format(Task_label, k_fold_index)):
        os.makedirs('../Data/{}/train/data{}'.format(Task_label, k_fold_index))
    train_data.to_csv('../Data/{}/train/data{}/train.tsv'.format(Task_label, k_fold_index), header=None, index=None, sep='\t')
    val_data.to_csv('../Data/{}/train/data{}/dev.tsv'.format(Task_label, k_fold_index), header=None, index=None, sep='\t')
    test_data.to_csv('../Data/{}/train/data{}/test.tsv'.format(Task_label, k_fold_index), header=None, index=None, sep='\t')

